
cd u:\files\papers\lindic\fr
clear
set more 1
set matsize 200
set memory 2000

log using defanal, replace
************************************************
* This program merges defdata.dta with some of the sample data
*
*
use datay96

** if rerunning:
*drop predsam defrati defrath predsamf
compress
sort country date
save datay96, replace

*predsam is 1 for observations where 1996 data is available, otherwise it is na
g predsam =1 if date== 1996 & ((comrat~=.) & (conrat~=.) & (varrat~=.) & (shorttot~=.) & (fdistock~=.) & (pubrat~=.) & (multirat~=.) & (debty~=.) & (canm~=.) & (overvalo~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (reservem~=. | (open~=. & ressh~=. & resm2 ~=.)))
keep country date predsam ss1
sort country date
save predsam, replace

*predsamf is 1 for all years where data is available for that country in 1996
by country: keep if _n == 27
drop date
rename predsam predsamf
sort country
save temp, replace
clear
use predsam
merge country using temp
tab _merge
drop _merge
sort country date
save predsam, replace

clear
use datay96
keep country date defrat
sort country date
save temp, replace
use defdata
sort country date
merge country date using temp, update
tab _merge
drop _merge
sort country date
merge country date using predsam, update
tab _merge
drop _merge


count if defrat ~= . & predsam == 1
count if ggbgnp ~= . & predsam == 1
count if ifsgnp ~= . & predsam == 1
count if ggbgdp ~= . & predsam == 1
count if ifsgdp ~= . & predsam == 1
count if cgbgdp ~= . & predsam == 1
count if cgbgnp ~= . & predsam == 1


count if defrat ~= . & ifsgnp ~= .
count if defrat ~= . & ggbgnp ~= .
pwcorr  ggbgnp ifsgnp defrat defratn

count if defrat ~= . & ifsgnp ~= . &  predsamf == 1
count if defrat ~= . & ggbgnp ~= . &  predsamf == 1
pwcorr  ggbgnp ifsgnp defrat if predsamf==1

count if defratn ~= . & ifsgnp ~= . &  date>= 1994
count if defratn ~= . & ggbgnp ~= . &  date>= 1994
count if defrat ~= . & ifsgnp ~= . &  date>= 1994
count if defrat ~= . & ggbgnp ~= . &  date>= 1994
pwcorr  ggbgnp ifsgnp defratn defrat if date>=1994

count if defrat ~= . & defratn ~= . &  date== 1994 | date==1995
pwcorr  ggbgnp ifsgnp defratn defrat if date>=1994 & date<1996

count if defrat ~= . & ifsgnp ~= . &  date>= 1994 & predsamf == 1
count if defrat ~= . & ggbgnp ~= . &  date>= 1994 & predsamf == 1
pwcorr  ggbgnp ifsgnp defratn if date>=1994 & predsamf==1

count if defrat ~= . & ifsgnp ~= . &  date== 1996
count if defrat ~= . & ggbgnp ~= . &  date== 1996
pwcorr  ggbgnp ifsgnp defratn if date==1996

count if defrat ~= . & ifsgnp ~= . &  date== 1996 & predsamf == 1
count if defrat ~= . & ggbgnp ~= . &  date== 1996 & predsamf == 1
pwcorr  ggbgnp ifsgnp defratn if date==1996 & predsamf==1


* OK, so make new variable for 1996: defrath is hybrid, defrat i is IFS
generate defrath = defrat
replace defrath = ifsgnp if date==1996
replace defrath = ggbgnp if date==1996 & defrath == .

g defrati = defrat
replace defrati = ifsgnp if date==1996

keep country date defrati defrath predsam predsamf
sort country date
save temp1, replace

clear
use datay96
drop _merge
sort country date
merge country date using temp1, update
tab _merge
drop _merge

save datay96, replace
log close

