
cd u:\files\papers\lindic\fr
set more 1
set matsize 200
set memory 2000

************************************************************************************************
* datay96c comes from Maria (that is, wdi97, gfs97, with some updates from IFS)
* Part 1 (old resup) makes datay96r, fixes reserves from wdi97,
*       It uses reserves.txt, from reserves.xls
* Part 2 (old mkdatad.do) makes datay96d, makes the vars for the regressions.
* Part 3 (old updat.do) makes datay96e.dta, fixes 96 from 1998 WDI for res, ressh, resm2, reservem only,
*       It uses 9496.txt, from 9496.xls
* Part 4 (old mergem.do) makes datay96f.dta, mergems reservesm from FR data set mydatav6.dta, where not missing
*       and difference is bigger than 5(?) percent.
*******************************************************************************************************



**********************************************************************************************
* Part I (old resup)
* This program starts with datay96c.dta (from WDI97 and GFS97, largely, with some fill-ins
*  by Maria, and udates reserve data from WDI97 where it is more than 5 percent off and where
*  the WDI97 data exists. It produces datay96r.dta

log using makedata.log, replace

insheet using reserves.txt

g resn97r = real(resn97)
drop resn97
rename resn97r resn97
rename countryc country
rename year date
drop countryn
* Wow: tricky bug: without this, some countries had no country name, which meant in at least a
*    couple of cases (why only these I don't know) they got out of order when sorted by
*    countryn in mkdatad.do, so the change variables were gone for 1996 for these 4(?) countries!

compress
sort country date

save resn97, replace


use datay96c.dta

drop _merge
sort country date

merge country date using resn97, update

tab _merge


g resd97 = 100*resn97/res-100
* edit country date resn97 res if abs(resd)>5 & resd ~= .

replace res = resn97 if abs(resd)>5 & resn97 ~= .

* drop _merge
compress
sort country date
save datay96, replace




*****************************************************************************
* Part II. (old Makedatad)
*
* use datay96r

encode country, gen(countryn)
sort countryn date
compress
*
* First, create an indicator variable for the event
*
g de=100.*(e/e[_n-1]-1) if countryn==countryn[_n-1]
replace de=. if countryn~=countryn[_n-1]
sort countryn date



g byte event1=0
replace event1=1 if ((de>25&de~=.)&((de-de[_n-1]>10)&de[_n-1]~=.))&(countryn==countryn[_n-1])
replace event1=. if countryn~=countryn[_n-1]

g byte event1w=0
replace event1w=1 if event1==1
replace event1w=. if event1==.

tab event1
tab event1w
sort countryn date

*
* Now "window" out adjacent values within three years
*
replace event1w=. if (event1w[_n-1]==1)&(countryn==countryn[_n-1])
replace event1w=. if (event1w[_n-2]==1)&(countryn==countryn[_n-2])
replace event1w=. if (event1w[_n-3]==1)&(countryn==countryn[_n-3])

replace event1w=. if (event1w[_n+1]==1)&(countryn==countryn[_n+1])
replace event1w=. if (event1w[_n+2]==1)&(countryn==countryn[_n+2])
replace event1w=. if (event1w[_n+3]==1)&(countryn==countryn[_n+3])

tab event1w
sort countryn date
list country date if event1w>.5&event1w~=.

*** NOW CLEAN THE DATA ITERATIVELY TO ENSURE THAT CRISES ARE MEASURED AS EARLY AS POSSIBLE

g event2=event1w

replace event2=1 if event1==1 & event2[_n-3]~=1 & ((event1[_n-4]==1 & countryn==countryn[_n-4])| ((event1[_n-5]==1) & countryn==countryn[_n-5]))

replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

*check his amount of crisis
count if event2==1

** SECOND ITERATION **
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

** THIRD ITERATION ***
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])
tab event2
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

sort countryn date
list country date if event2>.5 & event2~=.

g eventld=event2[_n+1]

* Now create the variables of interest
*
replace reservem=reservem*100.

g comrat=100.*comdebt/totdebt

g conrat=100.*condebt/totdebt

g varrat=100.*vardebt/totdebt

g pubrat=100.*pubdebt/totdebt

g defrat=(100.*def)/gnp

g dly=100.*(log(gnpt)-log(gnpt[_n-1])) if countryn==countryn[_n-1]
replace dly=. if countryn~=countryn[_n-1]

g dloecdy=100.*(log(oecdy)-log(oecdy[_n-1])) if countryn==countryn[_n-1]
replace dloecdy=. if countryn~=countryn[_n-1]

g dlcred=100.*(log(cred)-log(cred[_n-1])) if countryn==countryn[_n-1]
replace dlcred=. if countryn~=countryn[_n-1]

g dlres=100.*(log(res)-log(res[_n-1])) if countryn==countryn[_n-1]
replace dlres=. if countryn~=countryn[_n-1]

g fdistock=100.*fdi/totdebt

g prtstock=100.*portf/totdebt

* Real Exchange Rate; take deviations from country-specific average
*
g q=log(price/(usprice*e))
g overvaln=100.*q
quietly sum overvaln if country=="ARG"
replace overvaln=overvaln-_result(3) if country=="ARG"
quietly sum overvaln if country=="BDI"
replace overvaln=overvaln-_result(3) if country=="BDI"
quietly sum overvaln if country=="BEN"
replace overvaln=overvaln-_result(3) if country=="BEN"
quietly sum overvaln if country=="BFA"
replace overvaln=overvaln-_result(3) if country=="BFA"
quietly sum overvaln if country=="BGD"
replace overvaln=overvaln-_result(3) if country=="BGD"
quietly sum overvaln if country=="BLZ"
replace overvaln=overvaln-_result(3) if country=="BLZ"
quietly sum overvaln if country=="BOL"
replace overvaln=overvaln-_result(3) if country=="BOL"
quietly sum overvaln if country=="BRA"
replace overvaln=overvaln-_result(3) if country=="BRA"
quietly sum overvaln if country=="BRB"
replace overvaln=overvaln-_result(3) if country=="BRB"
quietly sum overvaln if country=="BTN"
replace overvaln=overvaln-_result(3) if country=="BTN"
quietly sum overvaln if country=="BWA"
replace overvaln=overvaln-_result(3) if country=="BWA"
quietly sum overvaln if country=="CAF"
replace overvaln=overvaln-_result(3) if country=="CAF"
quietly sum overvaln if country=="CHL"
replace overvaln=overvaln-_result(3) if country=="CHL"
quietly sum overvaln if country=="CHN"
replace overvaln=overvaln-_result(3) if country=="CHN"
quietly sum overvaln if country=="CIV"
replace overvaln=overvaln-_result(3) if country=="CIV"
quietly sum overvaln if country=="CMR"
replace overvaln=overvaln-_result(3) if country=="CMR"
quietly sum overvaln if country=="COG"
replace overvaln=overvaln-_result(3) if country=="COG"
quietly sum overvaln if country=="COL"
replace overvaln=overvaln-_result(3) if country=="COL"
quietly sum overvaln if country=="COM"
replace overvaln=overvaln-_result(3) if country=="COM"
quietly sum overvaln if country=="CPV"
replace overvaln=overvaln-_result(3) if country=="CPV"
quietly sum overvaln if country=="CRI"
replace overvaln=overvaln-_result(3) if country=="CRI"
quietly sum overvaln if country=="DJI"
replace overvaln=overvaln-_result(3) if country=="DJI"
quietly sum overvaln if country=="DOM"
replace overvaln=overvaln-_result(3) if country=="DOM"
quietly sum overvaln if country=="DZA"
replace overvaln=overvaln-_result(3) if country=="DZA"
quietly sum overvaln if country=="ECU"
replace overvaln=overvaln-_result(3) if country=="ECU"
quietly sum overvaln if country=="EGY"
replace overvaln=overvaln-_result(3) if country=="EGY"
quietly sum overvaln if country=="ETH"
replace overvaln=overvaln-_result(3) if country=="ETH"
quietly sum overvaln if country=="FJI"
replace overvaln=overvaln-_result(3) if country=="FJI"
quietly sum overvaln if country=="GAB"
replace overvaln=overvaln-_result(3) if country=="GAB"
quietly sum overvaln if country=="GHA"
replace overvaln=overvaln-_result(3) if country=="GHA"
quietly sum overvaln if country=="GIN"
replace overvaln=overvaln-_result(3) if country=="GIN"
quietly sum overvaln if country=="GMB"
replace overvaln=overvaln-_result(3) if country=="GMB"
quietly sum overvaln if country=="GNB"
replace overvaln=overvaln-_result(3) if country=="GNB"
quietly sum overvaln if country=="GNQ"
replace overvaln=overvaln-_result(3) if country=="GNQ"
quietly sum overvaln if country=="GRD"
replace overvaln=overvaln-_result(3) if country=="GRD"
quietly sum overvaln if country=="GTM"
replace overvaln=overvaln-_result(3) if country=="GTM"
quietly sum overvaln if country=="GUY"
replace overvaln=overvaln-_result(3) if country=="GUY"
quietly sum overvaln if country=="HND"
replace overvaln=overvaln-_result(3) if country=="HND"
quietly sum overvaln if country=="HTI"
replace overvaln=overvaln-_result(3) if country=="HTI"
quietly sum overvaln if country=="HUN"
replace overvaln=overvaln-_result(3) if country=="HUN"
quietly sum overvaln if country=="IDN"
replace overvaln=overvaln-_result(3) if country=="IDN"
quietly sum overvaln if country=="IND"
replace overvaln=overvaln-_result(3) if country=="IND"
quietly sum overvaln if country=="IRN"
replace overvaln=overvaln-_result(3) if country=="IRN"
quietly sum overvaln if country=="JAM"
replace overvaln=overvaln-_result(3) if country=="JAM"
quietly sum overvaln if country=="JOR"
replace overvaln=overvaln-_result(3) if country=="JOR"
quietly sum overvaln if country=="KEN"
replace overvaln=overvaln-_result(3) if country=="KEN"
quietly sum overvaln if country=="KOR"
replace overvaln=overvaln-_result(3) if country=="KOR"
quietly sum overvaln if country=="LAO"
replace overvaln=overvaln-_result(3) if country=="LAO"
quietly sum overvaln if country=="LBN"
replace overvaln=overvaln-_result(3) if country=="LBN"
quietly sum overvaln if country=="LBR"
replace overvaln=overvaln-_result(3) if country=="LBR"
quietly sum overvaln if country=="LKA"
replace overvaln=overvaln-_result(3) if country=="LKA"
quietly sum overvaln if country=="LSO"
replace overvaln=overvaln-_result(3) if country=="LSO"
quietly sum overvaln if country=="MAR"
replace overvaln=overvaln-_result(3) if country=="MAR"
quietly sum overvaln if country=="MDG"
replace overvaln=overvaln-_result(3) if country=="MDG"
quietly sum overvaln if country=="MDV"
replace overvaln=overvaln-_result(3) if country=="MDV"
quietly sum overvaln if country=="MEX"
replace overvaln=overvaln-_result(3) if country=="MEX"
quietly sum overvaln if country=="MLI"
replace overvaln=overvaln-_result(3) if country=="MLI"
quietly sum overvaln if country=="MLT"
replace overvaln=overvaln-_result(3) if country=="MLT"
quietly sum overvaln if country=="MMR"
replace overvaln=overvaln-_result(3) if country=="MMR"
quietly sum overvaln if country=="MRT"
replace overvaln=overvaln-_result(3) if country=="MRT"
quietly sum overvaln if country=="MUS"
replace overvaln=overvaln-_result(3) if country=="MUS"
quietly sum overvaln if country=="MWI"
replace overvaln=overvaln-_result(3) if country=="MWI"
quietly sum overvaln if country=="MYS"
replace overvaln=overvaln-_result(3) if country=="MYS"
quietly sum overvaln if country=="NER"
replace overvaln=overvaln-_result(3) if country=="NER"
quietly sum overvaln if country=="NGA"
replace overvaln=overvaln-_result(3) if country=="NGA"
quietly sum overvaln if country=="NIC"
replace overvaln=overvaln-_result(3) if country=="NIC"
quietly sum overvaln if country=="NPL"
replace overvaln=overvaln-_result(3) if country=="NPL"
quietly sum overvaln if country=="OMN"
replace overvaln=overvaln-_result(3) if country=="OMN"
quietly sum overvaln if country=="PAK"
replace overvaln=overvaln-_result(3) if country=="PAK"
quietly sum overvaln if country=="PAN"
replace overvaln=overvaln-_result(3) if country=="PAN"
quietly sum overvaln if country=="PER"
replace overvaln=overvaln-_result(3) if country=="PER"
quietly sum overvaln if country=="PHL"
replace overvaln=overvaln-_result(3) if country=="PHL"
quietly sum overvaln if country=="PNG"
replace overvaln=overvaln-_result(3) if country=="PNG"
quietly sum overvaln if country=="PRT"
replace overvaln=overvaln-_result(3) if country=="PRT"
quietly sum overvaln if country=="PRY"
replace overvaln=overvaln-_result(3) if country=="PRY"
quietly sum overvaln if country=="ROM"
replace overvaln=overvaln-_result(3) if country=="ROM"
quietly sum overvaln if country=="RWA"
replace overvaln=overvaln-_result(3) if country=="RWA"
quietly sum overvaln if country=="SDN"
replace overvaln=overvaln-_result(3) if country=="SDN"
quietly sum overvaln if country=="SEN"
replace overvaln=overvaln-_result(3) if country=="SEN"
quietly sum overvaln if country=="SLB"
replace overvaln=overvaln-_result(3) if country=="SLB"
quietly sum overvaln if country=="SLE"
replace overvaln=overvaln-_result(3) if country=="SLE"
quietly sum overvaln if country=="SLV"
replace overvaln=overvaln-_result(3) if country=="SLV"
quietly sum overvaln if country=="SOM"
replace overvaln=overvaln-_result(3) if country=="SOM"
quietly sum overvaln if country=="STP"
replace overvaln=overvaln-_result(3) if country=="STP"
quietly sum overvaln if country=="SWZ"
replace overvaln=overvaln-_result(3) if country=="SWZ"
quietly sum overvaln if country=="SYC"
replace overvaln=overvaln-_result(3) if country=="SYC"
quietly sum overvaln if country=="SYR"
replace overvaln=overvaln-_result(3) if country=="SYR"
quietly sum overvaln if country=="TCD"
replace overvaln=overvaln-_result(3) if country=="TCD"
quietly sum overvaln if country=="TGO"
replace overvaln=overvaln-_result(3) if country=="TGO"
quietly sum overvaln if country=="THA"
replace overvaln=overvaln-_result(3) if country=="THA"
quietly sum overvaln if country=="TTO"
replace overvaln=overvaln-_result(3) if country=="TTO"
quietly sum overvaln if country=="TUN"
replace overvaln=overvaln-_result(3) if country=="TUN"
quietly sum overvaln if country=="TUR"
replace overvaln=overvaln-_result(3) if country=="TUR"
quietly sum overvaln if country=="TZA"
replace overvaln=overvaln-_result(3) if country=="TZA"
quietly sum overvaln if country=="UGA"
replace overvaln=overvaln-_result(3) if country=="UGA"
quietly sum overvaln if country=="URY"
replace overvaln=overvaln-_result(3) if country=="URY"
quietly sum overvaln if country=="VCT"
replace overvaln=overvaln-_result(3) if country=="VCT"
quietly sum overvaln if country=="VEN"
replace overvaln=overvaln-_result(3) if country=="VEN"
quietly sum overvaln if country=="VUT"
replace overvaln=overvaln-_result(3) if country=="VUT"
quietly sum overvaln if country=="WSM"
replace overvaln=overvaln-_result(3) if country=="WSM"
quietly sum overvaln if country=="YEM"
replace overvaln=overvaln-_result(3) if country=="YEM"
quietly sum overvaln if country=="YUG"
replace overvaln=overvaln-_result(3) if country=="YUG"
quietly sum overvaln if country=="ZAR"
replace overvaln=overvaln-_result(3) if country=="ZAR"
quietly sum overvaln if country=="ZMB"
replace overvaln=overvaln-_result(3) if country=="ZMB"
quietly sum overvaln if country=="ZWE"
replace overvaln=overvaln-_result(3) if country=="ZWE"
*
* Now lag it
* we make the replacements conditional on previous calculations
g overval=overvaln
replace overval=overvaln[_n-1] if country==country[_n-1]
replace overval=. if country~=country[_n-1]
rename overvaln overvalo
rename overval overvaln
* overvalo is the "original" without lag variable
*

list country date overvalo overvaln in 1/66
*
*
* Non-Dollar Exchange Rate Variable Construction
*
g totshr=dolshr+dmshr+yenshr+ffrshr+swfshr+gbpshr

g dleb=-100.*(log(eb)-log(eb[_n-1])) if country==country[_n-1]
g dlef=100.*(log(ef)-log(ef[_n-1])) if country==country[_n-1]
g dleg=100.*(log(eg)-log(eg[_n-1])) if country==country[_n-1]
g dlej=100.*(log(ej)-log(ej[_n-1])) if country==country[_n-1]
g dles=100.*(log(es)-log(es[_n-1])) if country==country[_n-1]

g eexp=((dmshr/totshr)*dleg)+((yenshr/totshr)*dlej)+((ffrshr/totshr)*dlef)+((swfshr/totshr)*dles)+((gbpshr/totshr)*dleb)
*
* Foreign Interest Rate Variable Construction
*
g istar=((dolshr/totshr)*ius)+((dmshr/totshr)*ige)+((yenshr/totshr)*ija)+((ffrshr/totshr)*ifr)+((swfshr/totshr)*ich)+((gbpshr/totshr)*iuk)
sum istar
sum istar if totshr>65&totshr~=.
sum istar if totshr>90&totshr~=.


 * Now make debt variables a share of GDP

g comgdp=100*comdebt/gdp
g congdp=100*condebt/gdp
g vargdp=100*vardebt/gdp
g pubgdp=100*pubdebt/gdp
g multgdp=(multirat*totdebt)/gdp
g fdigdp=100*fdi/gdp
g shortgdp=(shorttot*totdebt)/gdp


g resm2=100*res*e/m2liab
g ressh=100*res/(shorttot*totdebt/100)

g m2res = 100*m2liab/(e*res)
g shres = 100*(shorttot*totdebt/100)/res

g mreserve = 100/reservem

g short = shorttot*totdebt/100
g m2 = e/m2liab
g imports = res/(reservem/100)

drop _merge
sort countryn date
save datay96.dta, replace


*********************************************************************************************
* Part III (old updat.do).
* This uses datay96d and makes datay96e. It updates the 1996 reserves variables from the
*   1998 WDI CD-rom
*   NOte it only does resm2, ressh, reservem, and res itself (not eg m2res).

clear

insheet using 9496.txt
* this comes from 9496.xls
* you don't need m2.txt, updat.txt, other varnames.txt, etc.

sort country date

g resr = real(res)
g totdebtr = real(debttot)
g m2liabr = real(m2liab)
g gnpr = real(gnp)
g rr = round(real(reservem)*100,10)
* This seems to be in the original Maria data. I don't know why.\

g sr = real(shorttot)
g defratr = real(deffat)
g defr = real(deffat)

* deffat is not really the ratio, it is the deficit in lcu

drop res deffat debttot m2liab gnp reservem shorttot

rename resr  resn
rename defr  defn
rename totdebtr  totdebtn
rename m2liabr  m2liabn
rename gnpr  gnpn
rename rr reservmn
rename sr shortttn

g defratn = 100*defn/gnpn

* g col1=1 if  (comrat~=.) & (conrat~=.) & (varrat~=.) & (shorttot~=.) & (fdistock~=.) & (pubrat~=.) & (multirat~=.) & (debty~=.) & (reservem~=.) & (canm~=.) & (overvalo~=.) & (defrat~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (dloecdy~=.)


compress

save 9496.dta, replace

use datay96.dta

sort country date

merge country date using 9496, update

tab _merge

* edit country date m2liab m2liab1

* For each country, the observations start in 1971, so _n=25 should be 1995.
* sort country
* by country: generate m2liab2 = m2liab1*m2liab[25]/m2liab1[25]
* check:
* edit country date m2liab m2liab1 m2liab2
* Now, replace 1996
* replace m2liab = m2liab2 if date==1996
* edit country date m2liab m2liab1 m2liab2


g resd = 100*resn/res-100
g defratd = 100*defratn/defrat-100
g totdebtd = 100*totdebtn/totdebt -100
g m2liabd = 100*m2liabn/m2liab -100
g gnpd = 100*gnpn/gnp-100
g reservmd = 100*reservmn/reservem -100
g shortttd = 100*shortttn/shorttot-100

g shortgpn=(shortttn*totdebtn)/gdp
g resm2n=100*resn*e/m2liabn
g resshn=100*resn/(shortttn*totdebtn/100)
g m2resn = 100*m2liabn/(e*resn)
g shresn = 100*(shortttn*totdebtn/100)/resn
g mreseren = 100/reservmn
g shortn = shortttn*totdebtn/100
g m2n = e/m2liabn
g importsn = resn/(reservmn/100)

g resm2d= 100*resm2n/resm2-100
g resshd = 100*resshn/ressh-100
drop resd
* This is because this was already created, I guess, in resup.

g resd = 100*resn/res-100


* edit country date res resn defrat defratn totdebt totdebtn m2liab m2liabn gnp gnpn reservem reservmn shorttot shortttn if _merge==3
* edit country date resd defratd totdebtd m2liabd gnpd reservmd shortttd if _merge==3 & (abs(defratd)>1 | abs(totdebtd)>1| abs(m2liabd)>1 | abs(gnpd)>1 | abs(reservmd)>1 | abs(shortttd)>1) & (date==1994 | date==1995)
* edit country date resn res resd if _merge==3 & abs(resd)>1 & (date==1994 | date==1995)
* edit country date m2liabn m2liab m2liabd if _merge==3 & abs(m2liabd)>1 & (date==1994 | date==1995)
* edit country date gnpn gnp gnpd if _merge==3 & abs(gnpd)>1 & (date==1994 | date==1995)
* edit country date defratn defrat defratd if _merge==3 & abs(defratd)>1 & (date==1994 | date==1995)

* edit country date defratn defrat reservmn reservem resm2n resm2 resshn ressh resn res if _merge==3 & ((abs(resd)>30 & abs(resd) ~= .) |(abs(defratd)>30 & abs(defratd) ~= .) | (abs(reservmd)>30 & abs(reservmd) ~= .) | (abs(resm2d)>30 & abs(resm2d) ~= . ) | (abs(resshd)>30 & abs(resshd) ~= .)) & (date==1994 | date==1995 | date==1996)

*Create Maria variables
g defrato = defrat
g reservmo = reservem
g resm2o = resm2
g ressho = ressh
g reso = res

*Update key 1996 variables for forecasts
replace defrat = defratn if date==1996
replace reservem = reservmn if date==1996
replace resm2 = resm2n if date==1996
replace ressh = resshn if date==1996
replace res = resn if date==1996

compress

save datay96, replace


************************************************************************************************
* Part 4 (old mergem)
* This program goes from datay96e to datay96f, using mydatav6. That is, it updates reservesm
*  data using the original FR data, where it exists alone.


clear
use mydatav6
g reservmx = round(reservem*100,10)
drop reservem
rename reservmx reservem
keep country date reservem
* edit country date reservem if country == "ARG" & date <= 1976
sort country date
save temp, replace

use datay96
drop _merge
sort country date
* edit country date reservem if country == "ARG" & date <= 1976
count if date<=1981 & reservem == .

merge country date using temp, update
* edit country date reservem if country == "ARG" & date <= 1976

tab _merge
sort country date
save datay96, replace

log close

* The end.



