
cd e:\files\papers\lindic\fr
log using t13act.log, replace
clear
set more 1
set matsize 200
set memory 2000

* column1
* This STATA program performs probit regressions linking events to current and
* lagged values of various regressors.
* Using all changes on to our revised data of table 1
* extending LHS variable until 1996
* An event is defined as >25% exchange rate change and a change in the rate of
* depreciation of at least 10%.
* overvaluation corrected
* lefthand side variable modified : % change and extra windowing
* Test uses canm and gnpt

use datay97
encode country, gen(countryn)
sort countryn date
compress
*
* First, create an indicator variable for the event
*
g de=100.*(e/e[_n-1]-1) if countryn==countryn[_n-1]
replace de=. if countryn~=countryn[_n-1]
sort countryn date



g byte event1=0
replace event1=1 if ((de>25&de~=.)&((de-de[_n-1]>10)&de[_n-1]~=.))&(countryn==countryn[_n-1])
replace event1=. if countryn~=countryn[_n-1]

g byte event1w=0
replace event1w=1 if event1==1
replace event1w=. if event1==.

tab event1
tab event1w
sort countryn date

*
* Now "window" out adjacent values within three years
*
replace event1w=. if (event1w[_n-1]==1)&(countryn==countryn[_n-1])
replace event1w=. if (event1w[_n-2]==1)&(countryn==countryn[_n-2])
replace event1w=. if (event1w[_n-3]==1)&(countryn==countryn[_n-3])

replace event1w=. if (event1w[_n+1]==1)&(countryn==countryn[_n+1])
replace event1w=. if (event1w[_n+2]==1)&(countryn==countryn[_n+2])
replace event1w=. if (event1w[_n+3]==1)&(countryn==countryn[_n+3])

tab event1w
sort countryn date
* list country date if event1w>.5&event1w~=.

*** NOW CLEAN THE DATA ITERATIVELY TO ENSURE THAT CRISES ARE MEASURED AS EARLY AS POSSIBLE

g event2=event1w

replace event2=1 if event1==1 & event2[_n-3]~=1 & ((event1[_n-4]==1 & countryn==countryn[_n-4])| ((event1[_n-5]==1) & countryn==countryn[_n-5]))

replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

*check his amount of crisis
count if event2==1

** SECOND ITERATION **
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

** THIRD ITERATION ***
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])
tab event2
replace event2=1 if event1==1 & event2[_n-1]~=1 & event2[_n-2]~=1 & event2[_n-3]~=1 & countryn==countryn[_n-3]
replace event2=. if (event2[_n-1]==1)&(countryn==countryn[_n-1])
replace event2=. if (event2[_n-2]==1)&(countryn==countryn[_n-2])
replace event2=. if (event2[_n-3]==1)&(countryn==countryn[_n-3])

replace event2=. if (event2[_n+1]==1)&(countryn==countryn[_n+1])
replace event2=. if (event2[_n+2]==1)&(countryn==countryn[_n+2])
replace event2=. if (event2[_n+3]==1)&(countryn==countryn[_n+3])

replace event2=0 if event1==0 & (event2[_n-1]~=1 | countryn~=countryn[_n-1])& (event2[_n-2]~=1 | countryn~=countryn[_n-2])& (event2[_n-3]~=1 | countryn~=countryn[_n-3])& (event2[_n+1]~=1 | countryn~=countryn[_n+1]) & (event2[_n+2]~=1 | countryn~=countryn[_n+2])& (event2[_n+3]~=1 | countryn~=countryn[_n+3])

tab event2

sort countryn date
* list country date if event2>.5 & event2~=.

g eventld=event2[_n+1]
g eventnw= event1[_n+1]
g deact = de[_n+1]
compress
sort country date

merge country date using predsam
tab _merge
drop _merge


* edit country deact eventld eventnw if date==1996 & predsam == 1
keep if date==1996
keep country date deact eventnw predsam predsamf
compress
sort country date
merge country date using fcasts, update
tab _merge
drop _merge

** Now to create the various ranks
* First, for prob1
gsort -prob1
g prob1r = _n if prob1 ~= .
g sam_1 = 1 if prob1 ~= .

gsort -prob1i
g prob1ir = _n if prob1i ~= .
g sam_1i = 1 if prob1i ~= .
gsort -prob1h
g prob1hr = _n if prob1h ~= .
g sam_1h = 1 if prob1h ~= .

gsort -prob2
g prob2r = _n  if prob2 ~= .
g sam_2 = 1 if prob2 ~= .

gsort ss1 -prob3
by ss1: g prob3r = _n if prob3 ~= .
replace prob3r = . if ss1 == 0
g sam_3 = 1 if prob3r ~= .

gsort ss1 -prob3i
by ss1: g prob3ir = _n if prob3i ~= .
replace prob3ir = . if ss1==0
g sam_3i = 1 if prob3ir ~= .

gsort ss1 -prob3h
by ss1: g prob3hr = _n if prob3h ~= .
replace prob3hr = . if ss1==0
g sam_3h = 1 if prob3hr ~= .

gsort ss1 -prob4
by ss1: g prob4r = _n if prob4 ~= .
replace prob4r = . if ss1==0
g sam_4 = 1 if prob4r ~= .

gsort ss1 -prob5
by ss1: g prob5r = _n if prob5 ~= .
replace prob5r = . if ss1==0
g sam_5 = 1 if prob5r ~= .

gsort ss1 -prob5i
by ss1: g prob5ir = _n if prob5i ~= .
replace prob5ir = . if ss1==0
g sam_5i = 1 if prob5ir ~= .

gsort ss1 -prob5h
by ss1: g prob5hr = _n if prob5h ~= .
replace prob5hr = . if ss1==0
g sam_5h = 1 if prob5hr ~= .

gsort ss1 -prob6
by ss1: g prob6r = _n if prob6 ~= .
replace prob6r=. if ss1==0
g sam_6 = 1 if prob6r ~= .

gsort sam_1 -deact country
by sam_1: g der_1 = _n
replace der_1 = . if sam_1 ~= 1
replace der_1 = der_1[_n-1] if deact==deact[_n-1] & sam_1 ==1

gsort sam_1i -deact country
by sam_1i: g der_1i = _n
replace der_1i = . if sam_1i ~= 1
replace der_1i = der_1i[_n-1] if deact==deact[_n-1] & sam_1i ==1

gsort sam_1h -deact country country
by sam_1h: g der_1h= _n
replace der_1h = . if sam_1h ~= 1
replace der_1h = der_1h[_n-1] if deact==deact[_n-1] & sam_1h ==1

gsort sam_2 -deact country
by sam_2: g der_2 = _n
replace der_2 = . if sam_2 ~= 1
replace der_2 = der_2[_n-1] if deact==deact[_n-1] & sam_2 ==1

gsort sam_3 -deact country
by sam_3: g der_3 = _n
replace der_3 = . if sam_3 ~= 1
replace der_3 = der_3[_n-1] if deact==deact[_n-1] & sam_3 ==1

gsort sam_3i -deact country
by sam_3i: g der_3i = _n
replace der_3i = . if sam_3i ~= 1
replace der_3i = der_3i[_n-1] if deact==deact[_n-1] & sam_3i ==1

gsort sam_3h -deact country
by sam_3h: g der_3h = _n
replace der_3h = . if sam_3h ~= 1
replace der_3h = der_3h[_n-1] if deact==deact[_n-1] & sam_3h ==1

gsort sam_4 -deact country
by sam_4: g der_4 = _n
replace der_4 = . if sam_4 ~= 1
replace der_4 = der_4[_n-1] if deact==deact[_n-1] & sam_4 ==1

gsort sam_5 -deact country
by sam_5: g der_5 = _n
replace der_5 = . if sam_5 ~= 1
replace der_5 = der_5[_n-1] if deact==deact[_n-1] & sam_5 ==1

gsort sam_5i -deact country
by sam_5i: g der_5i = _n
replace der_5i = . if sam_5i ~= 1
replace der_5i = der_5i[_n-1] if deact==deact[_n-1] & sam_5i ==1

gsort sam_5h -deact country
by sam_5h: g der_5h = _n
replace der_5h = . if sam_5h ~= 1
replace der_5h = der_5h[_n-1] if deact==deact[_n-1] & sam_5h ==1

gsort sam_6 -deact country
by sam_6: g der_6 = _n
replace der_6 = . if sam_6 ~= 1
replace der_6 = der_6[_n-1] if deact==deact[_n-1] & sam_6 ==1

gsort predsamf -deact country
by predsamf: g der_ps = _n
replace der_ps = . if predsamf ~= 1

g sam_i35h = 1 if sam_3h == 1 & sam_5h == 1
gsort sam_i35h -deact country
by sam_i35h: g der_i35 = _n
replace der_i35 = . if sam_i35h ~= 1
replace der_i35 = der_i35[_n-1] if deact==deact[_n-1] & sam_i35 ==1

g sam_u35h = 1 if (sam_3h == 1 | sam_5h == 1) & ss1==1
gsort sam_u35h -deact country
by sam_u35h: g der_u35 = _n
replace der_u35 = . if sam_u35h ~= 1
replace der_u35 = der_u35[_n-1] if deact==deact[_n-1] & sam_u35 ==1

gsort -prob3h
g p3h35r = _n if sam_i35h == 1
gsort -prob5h
g p5h35r = _n if sam_i35h == 1

gsort -deact
* edit country name der_ps der_1 prob1 prob1r prob1i prob1ir prob1h prob1hr prob2 prob2r prob3 prob3r prob4 der_5 prob5 prob5i der_5h prob5h prob6

regress der_1 prob1r
regress der_1i prob1ir
regress der_1i prob1ir if prob1r ~= .
regress der_1h prob1hr

regress der_2 prob2r

regress der_3 prob3r if ss1==1
regress der_3i prob3ir if ss1==1
regress der_3i prob3ir if prob3r ~= . & ss1==1
regress der_3h prob3hr if ss1==1
regress der_3h prob3hr if ss1==1 & prob3r ~= .
regress der_3h prob3hr if ss1==1 & prob3ir ~= .

regress der_4 prob4r if ss1==1
regress der_5 prob5r if ss1==1
regress der_5i prob5ir if ss1==1
regress der_5h prob5hr if ss1==1
regress der_6 prob6r if ss1==1


**************************************************************
************* TABLE 13a **************************************
*************************************************************
gsort -deact
* actual, actual rank, model 1 probability, model 1 rank
* list country name deact der_1h prob1h prob1hr if prob1hr ~= .
edit country name deact der_1h prob1h prob1hr if prob1hr ~= .
regress der_1h prob1hr

**************************************************************
************* TABLE 13b **************************************
*************************************************************
gsort -deact
* actual, actual rank, model 2 probability, model 2 rank, model 4 probability, model 4 rank
* list country name deact der_u35 prob3h prob3hr prob5h prob5hr if ss1==1 & der_u35 ~= .
edit country name deact der_u35 prob3h prob3hr prob5h prob5hr if ss1==1 & der_u35 ~= .

* model 2 R-squared and t-stat
regress der_3h prob3hr if ss1==1
* Model 4 r-squared and t-stat
regress der_5h prob5hr if ss1==1
* Model 2 r-squared and t-stat on common sample
regress der_i35 p3h35r if ss1==1
* Model 4 r-squared and t-stat on common sample
regress der_i35 p5h35r if ss1==1


log close
