
clear
cd u:\files\papers\lindic\fr

set more 1
set matsize 200
set memory 2000
* To show overvaluation mistake : this is what they did
* This STATA program performs probit regressions linking events to current and
* lagged values of various regressors.
*
* An event is defined as >25% exchange rate change and a change in the rate of
* depreciation of at least 10%.
* I will use this on mydatav6 results should be the same as their paper
* This program is a perturbation of TEST11b2.

use mydatav6
encode country, gen(countryn)
sort countryn date

compress
*
* First, create an indicator variable for the event
*
g dle=100.*(log(pdol)-log(pdol[_n-1])) if countryn==countryn[_n-1]
replace dle=. if countryn~=countryn[_n-1]

g byte event=0
replace event=1 if ((dle>25&dle~=.)&((dle-dle[_n-1]>10)&dle[_n-1]~=.))&(countryn==countryn[_n-1])
replace event=. if countryn~=countryn[_n-1]
tab event
sort countryn date
*
* Now "window" out adjacent values within three years
*
replace event=. if (event[_n-1]==1)&(countryn==countryn[_n-1])
replace event=. if (event[_n-2]==1)&(countryn==countryn[_n-2])
replace event=. if (event[_n-3]==1)&(countryn==countryn[_n-3])

replace event=. if (event[_n+1]==1)&(countryn==countryn[_n+1])
replace event=. if (event[_n+2]==1)&(countryn==countryn[_n+2])
replace event=. if (event[_n+3]==1)&(countryn==countryn[_n+3])
tab event
sort countryn date
list country date if event>.5&event~=.

g eventld=event[_n+1]
*
* Now create the variables of interest
*
replace reservem=reservem*100.

g comrat=100.*comdebt/totdebt

g conrat=100.*condebt/totdebt

g varrat=100.*vardebt/totdebt

g pubrat=100.*pubdebt/totdebt

g defrat=(100.*def)/gnp

g dly=100.*(log(gnppc)-log(gnppc[_n-1])) if countryn==countryn[_n-1]
replace dly=. if countryn~=countryn[_n-1]

g dloecdy=100.*(log(oecdy)-log(oecdy[_n-1])) if countryn==countryn[_n-1]
replace dloecdy=. if countryn~=countryn[_n-1]

g dlcred=100.*(log(cred)-log(cred[_n-1])) if countryn==countryn[_n-1]
replace dlcred=. if countryn~=countryn[_n-1]

g dlres=100.*(log(res)-log(res[_n-1])) if countryn==countryn[_n-1]
replace dlres=. if countryn~=countryn[_n-1]

g fdistock=100.*fdi/totdebt

g prtstock=100.*portf/totdebt
*
* Real Exchange Rate; take deviations from country-specific average
*
g q=log(price/(usprice*pdol))
g overvaln=100.*q
quietly sum overvaln if country=="ARG"
replace overvaln=overvaln-_result(3) if country=="ARG"
quietly sum overvaln if country=="BDI"
replace overvaln=overvaln-_result(3) if country=="BDI"
quietly sum overvaln if country=="BEN"
replace overvaln=overvaln-_result(3) if country=="BEN"
quietly sum overvaln if country=="BFA"
replace overvaln=overvaln-_result(3) if country=="BFA"
quietly sum overvaln if country=="BGD"
replace overvaln=overvaln-_result(3) if country=="BGD"
quietly sum overvaln if country=="BLZ"
replace overvaln=overvaln-_result(3) if country=="BLZ"
quietly sum overvaln if country=="BOL"
replace overvaln=overvaln-_result(3) if country=="BOL"
quietly sum overvaln if country=="BRA"
replace overvaln=overvaln-_result(3) if country=="BRA"
quietly sum overvaln if country=="BRB"
replace overvaln=overvaln-_result(3) if country=="BRB"
quietly sum overvaln if country=="BTN"
replace overvaln=overvaln-_result(3) if country=="BTN"
quietly sum overvaln if country=="BWA"
replace overvaln=overvaln-_result(3) if country=="BWA"
quietly sum overvaln if country=="CAF"
replace overvaln=overvaln-_result(3) if country=="CAF"
quietly sum overvaln if country=="CHL"
replace overvaln=overvaln-_result(3) if country=="CHL"
quietly sum overvaln if country=="CHN"
replace overvaln=overvaln-_result(3) if country=="CHN"
quietly sum overvaln if country=="CIV"
replace overvaln=overvaln-_result(3) if country=="CIV"
quietly sum overvaln if country=="CMR"
replace overvaln=overvaln-_result(3) if country=="CMR"
quietly sum overvaln if country=="COG"
replace overvaln=overvaln-_result(3) if country=="COG"
quietly sum overvaln if country=="COL"
replace overvaln=overvaln-_result(3) if country=="COL"
quietly sum overvaln if country=="COM"
replace overvaln=overvaln-_result(3) if country=="COM"
quietly sum overvaln if country=="CPV"
replace overvaln=overvaln-_result(3) if country=="CPV"
quietly sum overvaln if country=="CRI"
replace overvaln=overvaln-_result(3) if country=="CRI"
quietly sum overvaln if country=="DJI"
replace overvaln=overvaln-_result(3) if country=="DJI"
quietly sum overvaln if country=="DOM"
replace overvaln=overvaln-_result(3) if country=="DOM"
quietly sum overvaln if country=="DZA"
replace overvaln=overvaln-_result(3) if country=="DZA"
quietly sum overvaln if country=="ECU"
replace overvaln=overvaln-_result(3) if country=="ECU"
quietly sum overvaln if country=="EGY"
replace overvaln=overvaln-_result(3) if country=="EGY"
quietly sum overvaln if country=="ETH"
replace overvaln=overvaln-_result(3) if country=="ETH"
quietly sum overvaln if country=="FJI"
replace overvaln=overvaln-_result(3) if country=="FJI"
quietly sum overvaln if country=="GAB"
replace overvaln=overvaln-_result(3) if country=="GAB"
quietly sum overvaln if country=="GHA"
replace overvaln=overvaln-_result(3) if country=="GHA"
quietly sum overvaln if country=="GIN"
replace overvaln=overvaln-_result(3) if country=="GIN"
quietly sum overvaln if country=="GMB"
replace overvaln=overvaln-_result(3) if country=="GMB"
quietly sum overvaln if country=="GNB"
replace overvaln=overvaln-_result(3) if country=="GNB"
quietly sum overvaln if country=="GNQ"
replace overvaln=overvaln-_result(3) if country=="GNQ"
quietly sum overvaln if country=="GRD"
replace overvaln=overvaln-_result(3) if country=="GRD"
quietly sum overvaln if country=="GTM"
replace overvaln=overvaln-_result(3) if country=="GTM"
quietly sum overvaln if country=="GUY"
replace overvaln=overvaln-_result(3) if country=="GUY"
quietly sum overvaln if country=="HND"
replace overvaln=overvaln-_result(3) if country=="HND"
quietly sum overvaln if country=="HTI"
replace overvaln=overvaln-_result(3) if country=="HTI"
quietly sum overvaln if country=="HUN"
replace overvaln=overvaln-_result(3) if country=="HUN"
quietly sum overvaln if country=="IDN"
replace overvaln=overvaln-_result(3) if country=="IDN"
quietly sum overvaln if country=="IND"
replace overvaln=overvaln-_result(3) if country=="IND"
quietly sum overvaln if country=="IRN"
replace overvaln=overvaln-_result(3) if country=="IRN"
quietly sum overvaln if country=="JAM"
replace overvaln=overvaln-_result(3) if country=="JAM"
quietly sum overvaln if country=="JOR"
replace overvaln=overvaln-_result(3) if country=="JOR"
quietly sum overvaln if country=="KEN"
replace overvaln=overvaln-_result(3) if country=="KEN"
quietly sum overvaln if country=="KOR"
replace overvaln=overvaln-_result(3) if country=="KOR"
quietly sum overvaln if country=="LAO"
replace overvaln=overvaln-_result(3) if country=="LAO"
quietly sum overvaln if country=="LBN"
replace overvaln=overvaln-_result(3) if country=="LBN"
quietly sum overvaln if country=="LBR"
replace overvaln=overvaln-_result(3) if country=="LBR"
quietly sum overvaln if country=="LKA"
replace overvaln=overvaln-_result(3) if country=="LKA"
quietly sum overvaln if country=="LSO"
replace overvaln=overvaln-_result(3) if country=="LSO"
quietly sum overvaln if country=="MAR"
replace overvaln=overvaln-_result(3) if country=="MAR"
quietly sum overvaln if country=="MDG"
replace overvaln=overvaln-_result(3) if country=="MDG"
quietly sum overvaln if country=="MDV"
replace overvaln=overvaln-_result(3) if country=="MDV"
quietly sum overvaln if country=="MEX"
replace overvaln=overvaln-_result(3) if country=="MEX"
quietly sum overvaln if country=="MLI"
replace overvaln=overvaln-_result(3) if country=="MLI"
quietly sum overvaln if country=="MLT"
replace overvaln=overvaln-_result(3) if country=="MLT"
quietly sum overvaln if country=="MMR"
replace overvaln=overvaln-_result(3) if country=="MMR"
quietly sum overvaln if country=="MRT"
replace overvaln=overvaln-_result(3) if country=="MRT"
quietly sum overvaln if country=="MUS"
replace overvaln=overvaln-_result(3) if country=="MUS"
quietly sum overvaln if country=="MWI"
replace overvaln=overvaln-_result(3) if country=="MWI"
quietly sum overvaln if country=="MYS"
replace overvaln=overvaln-_result(3) if country=="MYS"
quietly sum overvaln if country=="NER"
replace overvaln=overvaln-_result(3) if country=="NER"
quietly sum overvaln if country=="NGA"
replace overvaln=overvaln-_result(3) if country=="NGA"
quietly sum overvaln if country=="NIC"
replace overvaln=overvaln-_result(3) if country=="NIC"
quietly sum overvaln if country=="NPL"
replace overvaln=overvaln-_result(3) if country=="NPL"
quietly sum overvaln if country=="OMN"
replace overvaln=overvaln-_result(3) if country=="OMN"
quietly sum overvaln if country=="PAK"
replace overvaln=overvaln-_result(3) if country=="PAK"
quietly sum overvaln if country=="PAN"
replace overvaln=overvaln-_result(3) if country=="PAN"
quietly sum overvaln if country=="PER"
replace overvaln=overvaln-_result(3) if country=="PER"
quietly sum overvaln if country=="PHL"
replace overvaln=overvaln-_result(3) if country=="PHL"
quietly sum overvaln if country=="PNG"
replace overvaln=overvaln-_result(3) if country=="PNG"
quietly sum overvaln if country=="PRT"
replace overvaln=overvaln-_result(3) if country=="PRT"
quietly sum overvaln if country=="PRY"
replace overvaln=overvaln-_result(3) if country=="PRY"
quietly sum overvaln if country=="ROM"
replace overvaln=overvaln-_result(3) if country=="ROM"
quietly sum overvaln if country=="RWA"
replace overvaln=overvaln-_result(3) if country=="RWA"
quietly sum overvaln if country=="SDN"
replace overvaln=overvaln-_result(3) if country=="SDN"
quietly sum overvaln if country=="SEN"
replace overvaln=overvaln-_result(3) if country=="SEN"
quietly sum overvaln if country=="SLB"
replace overvaln=overvaln-_result(3) if country=="SLB"
quietly sum overvaln if country=="SLE"
replace overvaln=overvaln-_result(3) if country=="SLE"
quietly sum overvaln if country=="SLV"
replace overvaln=overvaln-_result(3) if country=="SLV"
quietly sum overvaln if country=="SOM"
replace overvaln=overvaln-_result(3) if country=="SOM"
quietly sum overvaln if country=="STP"
replace overvaln=overvaln-_result(3) if country=="STP"
quietly sum overvaln if country=="SWZ"
replace overvaln=overvaln-_result(3) if country=="SWZ"
quietly sum overvaln if country=="SYC"
replace overvaln=overvaln-_result(3) if country=="SYC"
quietly sum overvaln if country=="SYR"
replace overvaln=overvaln-_result(3) if country=="SYR"
quietly sum overvaln if country=="TCD"
replace overvaln=overvaln-_result(3) if country=="TCD"
quietly sum overvaln if country=="TGO"
replace overvaln=overvaln-_result(3) if country=="TGO"
quietly sum overvaln if country=="THA"
replace overvaln=overvaln-_result(3) if country=="THA"
quietly sum overvaln if country=="TTO"
replace overvaln=overvaln-_result(3) if country=="TTO"
quietly sum overvaln if country=="TUN"
replace overvaln=overvaln-_result(3) if country=="TUN"
quietly sum overvaln if country=="TUR"
replace overvaln=overvaln-_result(3) if country=="TUR"
quietly sum overvaln if country=="TZA"
replace overvaln=overvaln-_result(3) if country=="TZA"
quietly sum overvaln if country=="UGA"
replace overvaln=overvaln-_result(3) if country=="UGA"
quietly sum overvaln if country=="URY"
replace overvaln=overvaln-_result(3) if country=="URY"
quietly sum overvaln if country=="VCT"
replace overvaln=overvaln-_result(3) if country=="VCT"
quietly sum overvaln if country=="VEN"
replace overvaln=overvaln-_result(3) if country=="VEN"
quietly sum overvaln if country=="VUT"
replace overvaln=overvaln-_result(3) if country=="VUT"
quietly sum overvaln if country=="WSM"
replace overvaln=overvaln-_result(3) if country=="WSM"
quietly sum overvaln if country=="YEM"
replace overvaln=overvaln-_result(3) if country=="YEM"
quietly sum overvaln if country=="YUG"
replace overvaln=overvaln-_result(3) if country=="YUG"
quietly sum overvaln if country=="ZAR"
replace overvaln=overvaln-_result(3) if country=="ZAR"
quietly sum overvaln if country=="ZMB"
replace overvaln=overvaln-_result(3) if country=="ZMB"
quietly sum overvaln if country=="ZWE"
replace overvaln=overvaln-_result(3) if country=="ZWE"
* HERE IS THE MISTAKE
* Now lag it
*
replace overvaln=overvaln[_n-1] if country==country[_n-1]
replace overvaln=. if country~=country[_n-1]
*
* Non-Dollar Exchange Rate Variable Construction
*
g totshr=dolshr+dmshr+yenshr+ffrshr+swfshr+gbpshr

g dleb=-100.*(log(eb)-log(eb[_n-1])) if country==country[_n-1]
g dlef=100.*(log(ef)-log(ef[_n-1])) if country==country[_n-1]
g dleg=100.*(log(eg)-log(eg[_n-1])) if country==country[_n-1]
g dlej=100.*(log(ej)-log(ej[_n-1])) if country==country[_n-1]
g dles=100.*(log(es)-log(es[_n-1])) if country==country[_n-1]

g eexp=((dmshr/totshr)*dleg)+((yenshr/totshr)*dlej)+((ffrshr/totshr)*dlef)+((swfshr/totshr)*dles)+((gbpshr/totshr)*dleb)
*
* Foreign Interest Rate Variable Construction
*
g istar=((dolshr/totshr)*ius)+((dmshr/totshr)*ige)+((yenshr/totshr)*ija)+((ffrshr/totshr)*ifr)+((swfshr/totshr)*ich)+((gbpshr/totshr)*iuk)
sum istar
sum istar if totshr>65&totshr~=.
sum istar if totshr>90&totshr~=.

* Default
*
dprobit event comrat conrat varrat shorttot fdistock pubrat multirat debty reservem cacc overvaln defrat dlcred dly istar dloecdy
*
* Significance of debt characteristics
*
test comrat conrat varrat fdistock shorttot pubrat multirat
*
* Significance of external characteristics
*
test reservem defrat cacc overvaln
*
* Significance of macro characteristics
*
test defrat dly dlcred
*
* Significance of foreign characteristics
*
test istar dloecdy
*


*****************************************************************************************

log using table6.log, replace

* * *  HERE IS Table 6 COLUMN 1 *******

* Default for the lead of event (1-year prediction)
*
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem cacc overvaln defrat dlcred dly istar dloecdy
*
* Significance of debt characteristics
*
test comrat conrat varrat fdistock shorttot pubrat multirat
*
* Significance of external characteristics
*
test reservem debty cacc overvaln
*
* Significance of macro characteristics
*
test defrat dly dlcred
*
* Significance of foreign characteristics
*
test istar dloecdy

* double checking overvaln mistake
* list country date overvaln in 1/66

* we generate a variable to mark the original sample
g osample=1 if (eventld~=.)&(comrat~=.)&(conrat~=.)&(varrat~=.)&(shorttot~=.)& (fdistock~=.)& (pubrat~=.)& (multirat~=.) & (debty~=.) & (reservem~=.) & (cacc~=.) & (overvaln~=.) &(defrat~=.) & (dlcred~=.) & (dly~=.) & (istar~=.) & (dloecdy~=.)
count if osample==1


** HERE IS TABLE FOR COLUMN 1

* create a cross-tab of hits and misses

predict prob
replace prob=1 if prob>.5 & prob~=.
replace prob=0 if prob<.5
tab prob eventld

* 0.25 cutoff
predict prob4
replace prob4=1 if prob4>.25 & prob4~=.
replace prob4=0 if prob4<.25
tab prob4 eventld

log close
********************************************************************************


* now we run the same regression with overvaluation corrected on their dataset
drop overvaln

* Real Exchange Rate; take deviations from country-specific average
*
g overvaln=100.*q
quietly sum overvaln if country=="ARG"
replace overvaln=overvaln-_result(3) if country=="ARG"
quietly sum overvaln if country=="BDI"
replace overvaln=overvaln-_result(3) if country=="BDI"
quietly sum overvaln if country=="BEN"
replace overvaln=overvaln-_result(3) if country=="BEN"
quietly sum overvaln if country=="BFA"
replace overvaln=overvaln-_result(3) if country=="BFA"
quietly sum overvaln if country=="BGD"
replace overvaln=overvaln-_result(3) if country=="BGD"
quietly sum overvaln if country=="BLZ"
replace overvaln=overvaln-_result(3) if country=="BLZ"
quietly sum overvaln if country=="BOL"
replace overvaln=overvaln-_result(3) if country=="BOL"
quietly sum overvaln if country=="BRA"
replace overvaln=overvaln-_result(3) if country=="BRA"
quietly sum overvaln if country=="BRB"
replace overvaln=overvaln-_result(3) if country=="BRB"
quietly sum overvaln if country=="BTN"
replace overvaln=overvaln-_result(3) if country=="BTN"
quietly sum overvaln if country=="BWA"
replace overvaln=overvaln-_result(3) if country=="BWA"
quietly sum overvaln if country=="CAF"
replace overvaln=overvaln-_result(3) if country=="CAF"
quietly sum overvaln if country=="CHL"
replace overvaln=overvaln-_result(3) if country=="CHL"
quietly sum overvaln if country=="CHN"
replace overvaln=overvaln-_result(3) if country=="CHN"
quietly sum overvaln if country=="CIV"
replace overvaln=overvaln-_result(3) if country=="CIV"
quietly sum overvaln if country=="CMR"
replace overvaln=overvaln-_result(3) if country=="CMR"
quietly sum overvaln if country=="COG"
replace overvaln=overvaln-_result(3) if country=="COG"
quietly sum overvaln if country=="COL"
replace overvaln=overvaln-_result(3) if country=="COL"
quietly sum overvaln if country=="COM"
replace overvaln=overvaln-_result(3) if country=="COM"
quietly sum overvaln if country=="CPV"
replace overvaln=overvaln-_result(3) if country=="CPV"
quietly sum overvaln if country=="CRI"
replace overvaln=overvaln-_result(3) if country=="CRI"
quietly sum overvaln if country=="DJI"
replace overvaln=overvaln-_result(3) if country=="DJI"
quietly sum overvaln if country=="DOM"
replace overvaln=overvaln-_result(3) if country=="DOM"
quietly sum overvaln if country=="DZA"
replace overvaln=overvaln-_result(3) if country=="DZA"
quietly sum overvaln if country=="ECU"
replace overvaln=overvaln-_result(3) if country=="ECU"
quietly sum overvaln if country=="EGY"
replace overvaln=overvaln-_result(3) if country=="EGY"
quietly sum overvaln if country=="ETH"
replace overvaln=overvaln-_result(3) if country=="ETH"
quietly sum overvaln if country=="FJI"
replace overvaln=overvaln-_result(3) if country=="FJI"
quietly sum overvaln if country=="GAB"
replace overvaln=overvaln-_result(3) if country=="GAB"
quietly sum overvaln if country=="GHA"
replace overvaln=overvaln-_result(3) if country=="GHA"
quietly sum overvaln if country=="GIN"
replace overvaln=overvaln-_result(3) if country=="GIN"
quietly sum overvaln if country=="GMB"
replace overvaln=overvaln-_result(3) if country=="GMB"
quietly sum overvaln if country=="GNB"
replace overvaln=overvaln-_result(3) if country=="GNB"
quietly sum overvaln if country=="GNQ"
replace overvaln=overvaln-_result(3) if country=="GNQ"
quietly sum overvaln if country=="GRD"
replace overvaln=overvaln-_result(3) if country=="GRD"
quietly sum overvaln if country=="GTM"
replace overvaln=overvaln-_result(3) if country=="GTM"
quietly sum overvaln if country=="GUY"
replace overvaln=overvaln-_result(3) if country=="GUY"
quietly sum overvaln if country=="HND"
replace overvaln=overvaln-_result(3) if country=="HND"
quietly sum overvaln if country=="HTI"
replace overvaln=overvaln-_result(3) if country=="HTI"
quietly sum overvaln if country=="HUN"
replace overvaln=overvaln-_result(3) if country=="HUN"
quietly sum overvaln if country=="IDN"
replace overvaln=overvaln-_result(3) if country=="IDN"
quietly sum overvaln if country=="IND"
replace overvaln=overvaln-_result(3) if country=="IND"
quietly sum overvaln if country=="IRN"
replace overvaln=overvaln-_result(3) if country=="IRN"
quietly sum overvaln if country=="JAM"
replace overvaln=overvaln-_result(3) if country=="JAM"
quietly sum overvaln if country=="JOR"
replace overvaln=overvaln-_result(3) if country=="JOR"
quietly sum overvaln if country=="KEN"
replace overvaln=overvaln-_result(3) if country=="KEN"
quietly sum overvaln if country=="KOR"
replace overvaln=overvaln-_result(3) if country=="KOR"
quietly sum overvaln if country=="LAO"
replace overvaln=overvaln-_result(3) if country=="LAO"
quietly sum overvaln if country=="LBN"
replace overvaln=overvaln-_result(3) if country=="LBN"
quietly sum overvaln if country=="LBR"
replace overvaln=overvaln-_result(3) if country=="LBR"
quietly sum overvaln if country=="LKA"
replace overvaln=overvaln-_result(3) if country=="LKA"
quietly sum overvaln if country=="LSO"
replace overvaln=overvaln-_result(3) if country=="LSO"
quietly sum overvaln if country=="MAR"
replace overvaln=overvaln-_result(3) if country=="MAR"
quietly sum overvaln if country=="MDG"
replace overvaln=overvaln-_result(3) if country=="MDG"
quietly sum overvaln if country=="MDV"
replace overvaln=overvaln-_result(3) if country=="MDV"
quietly sum overvaln if country=="MEX"
replace overvaln=overvaln-_result(3) if country=="MEX"
quietly sum overvaln if country=="MLI"
replace overvaln=overvaln-_result(3) if country=="MLI"
quietly sum overvaln if country=="MLT"
replace overvaln=overvaln-_result(3) if country=="MLT"
quietly sum overvaln if country=="MMR"
replace overvaln=overvaln-_result(3) if country=="MMR"
quietly sum overvaln if country=="MRT"
replace overvaln=overvaln-_result(3) if country=="MRT"
quietly sum overvaln if country=="MUS"
replace overvaln=overvaln-_result(3) if country=="MUS"
quietly sum overvaln if country=="MWI"
replace overvaln=overvaln-_result(3) if country=="MWI"
quietly sum overvaln if country=="MYS"
replace overvaln=overvaln-_result(3) if country=="MYS"
quietly sum overvaln if country=="NER"
replace overvaln=overvaln-_result(3) if country=="NER"
quietly sum overvaln if country=="NGA"
replace overvaln=overvaln-_result(3) if country=="NGA"
quietly sum overvaln if country=="NIC"
replace overvaln=overvaln-_result(3) if country=="NIC"
quietly sum overvaln if country=="NPL"
replace overvaln=overvaln-_result(3) if country=="NPL"
quietly sum overvaln if country=="OMN"
replace overvaln=overvaln-_result(3) if country=="OMN"
quietly sum overvaln if country=="PAK"
replace overvaln=overvaln-_result(3) if country=="PAK"
quietly sum overvaln if country=="PAN"
replace overvaln=overvaln-_result(3) if country=="PAN"
quietly sum overvaln if country=="PER"
replace overvaln=overvaln-_result(3) if country=="PER"
quietly sum overvaln if country=="PHL"
replace overvaln=overvaln-_result(3) if country=="PHL"
quietly sum overvaln if country=="PNG"
replace overvaln=overvaln-_result(3) if country=="PNG"
quietly sum overvaln if country=="PRT"
replace overvaln=overvaln-_result(3) if country=="PRT"
quietly sum overvaln if country=="PRY"
replace overvaln=overvaln-_result(3) if country=="PRY"
quietly sum overvaln if country=="ROM"
replace overvaln=overvaln-_result(3) if country=="ROM"
quietly sum overvaln if country=="RWA"
replace overvaln=overvaln-_result(3) if country=="RWA"
quietly sum overvaln if country=="SDN"
replace overvaln=overvaln-_result(3) if country=="SDN"
quietly sum overvaln if country=="SEN"
replace overvaln=overvaln-_result(3) if country=="SEN"
quietly sum overvaln if country=="SLB"
replace overvaln=overvaln-_result(3) if country=="SLB"
quietly sum overvaln if country=="SLE"
replace overvaln=overvaln-_result(3) if country=="SLE"
quietly sum overvaln if country=="SLV"
replace overvaln=overvaln-_result(3) if country=="SLV"
quietly sum overvaln if country=="SOM"
replace overvaln=overvaln-_result(3) if country=="SOM"
quietly sum overvaln if country=="STP"
replace overvaln=overvaln-_result(3) if country=="STP"
quietly sum overvaln if country=="SWZ"
replace overvaln=overvaln-_result(3) if country=="SWZ"
quietly sum overvaln if country=="SYC"
replace overvaln=overvaln-_result(3) if country=="SYC"
quietly sum overvaln if country=="SYR"
replace overvaln=overvaln-_result(3) if country=="SYR"
quietly sum overvaln if country=="TCD"
replace overvaln=overvaln-_result(3) if country=="TCD"
quietly sum overvaln if country=="TGO"
replace overvaln=overvaln-_result(3) if country=="TGO"
quietly sum overvaln if country=="THA"
replace overvaln=overvaln-_result(3) if country=="THA"
quietly sum overvaln if country=="TTO"
replace overvaln=overvaln-_result(3) if country=="TTO"
quietly sum overvaln if country=="TUN"
replace overvaln=overvaln-_result(3) if country=="TUN"
quietly sum overvaln if country=="TUR"
replace overvaln=overvaln-_result(3) if country=="TUR"
quietly sum overvaln if country=="TZA"
replace overvaln=overvaln-_result(3) if country=="TZA"
quietly sum overvaln if country=="UGA"
replace overvaln=overvaln-_result(3) if country=="UGA"
quietly sum overvaln if country=="URY"
replace overvaln=overvaln-_result(3) if country=="URY"
quietly sum overvaln if country=="VCT"
replace overvaln=overvaln-_result(3) if country=="VCT"
quietly sum overvaln if country=="VEN"
replace overvaln=overvaln-_result(3) if country=="VEN"
quietly sum overvaln if country=="VUT"
replace overvaln=overvaln-_result(3) if country=="VUT"
quietly sum overvaln if country=="WSM"
replace overvaln=overvaln-_result(3) if country=="WSM"
quietly sum overvaln if country=="YEM"
replace overvaln=overvaln-_result(3) if country=="YEM"
quietly sum overvaln if country=="YUG"
replace overvaln=overvaln-_result(3) if country=="YUG"
quietly sum overvaln if country=="ZAR"
replace overvaln=overvaln-_result(3) if country=="ZAR"
quietly sum overvaln if country=="ZMB"
replace overvaln=overvaln-_result(3) if country=="ZMB"
quietly sum overvaln if country=="ZWE"
replace overvaln=overvaln-_result(3) if country=="ZWE"

* HERE IS THE MISTAKE
* Now lag it
*
*replace overvaln=overvaln[_n-1] if country==country[_n-1]
*replace overvaln=. if country~=country[_n-1]
* to fix this we make the replacements conditional on previous calculations
g overval=overvaln
replace overval=overvaln[_n-1] if country==country[_n-1]
replace overval=. if country~=country[_n-1]
rename overvaln overvalo
rename overval overvaln
* overvalo is without lagging the variable
list country date overvalo overvaln in 1/66


********************************************************************************************************
log using table6.log, append

* Table6 column 1a [not shown, old column 2]
*
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem cacc overvalo defrat dlcred dly istar dloecdy if osample==1

*
* Significance of debt characteristics
*
test comrat conrat varrat fdistock shorttot pubrat multirat
*
* Significance of external characteristics
*
test reservem debty cacc overvalo
*
* Significance of macro characteristics
*
test defrat dly dlcred
*
* Significance of foreign characteristics
*
test istar dloecdy

* double checking overvaln mistake
* list country date overvalo overvaln in 1/66

* create a cross-tab of hits and misses

**

predict pred
replace pred=1 if pred>.5 & pred~=.
replace pred=0 if pred<.5
tab pred eventld if osample==1


log close

