**********************************************************************************
clear
cd u:\files\papers\lindic\fr

log using table6.log, append

set more 1
set matsize 200
set memory 2000

* This STATA program performs probit regressions linking events to current and
* lagged values of various regressors.
* Using commons sample of size 627
* An event is defined as >25% exchange rate change and a change in the rate of
* depreciation of at least 10%.





*************************************************************************


* get common sample
use datay96

* drop _merge
sort country date
merge country date using tab1sams, update
tab _merge

* column5
* This STATA program performs probit regressions linking events to current and
* lagged values of various regressors.
* Using commons sample of size 631 on revised data
* An event is defined as >25% exchange rate change and a change in the rate of
* depreciation of at least 10%.
* overvaluation corrected
* lefthand side variable modified : % change and extra windowing
* Test uses canm and gnpt



**********************************************************************************
 * Here is OLD COLUMN 5
**********************************************************************************

dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if c45sam==1

* Significance of debt characteristics
*
test comrat conrat varrat fdistock shorttot pubrat multirat
*
* Significance of external characteristics
*
test reservem debty canm overvalo
*
* Significance of macro characteristics
*
test defrat dly dlcred
*
* Significance of foreign characteristics
*
test istar dloecdy

* double checking overvaln mistake
* list country date overvaln in 1/66

* THIS IS TABLE FOR OLD COLUMN 5

predict pred

replace pred=1 if pred>.5 & pred~=.
replace pred=0 if pred<.5
tab pred eventld if c45sam==1

**********************************************************************************
 * Here is Column 2 (for paper), old column 6
**********************************************************************************


dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if date<=1992
dprobit eventld comrat conrat varrat shorttot fdistock pubrat multirat debty reservem canm overvalo defrat dlcred dly istar dloecdy if c6sample ==1
* should be the same as previous regression

* Significance of debt characteristics
*
test comrat conrat varrat fdistock shorttot pubrat multirat
*
* Significance of external characteristics
*
test reservem debty canm overvalo
*
* Significance of macro characteristics
*
test defrat dly dlcred
*
* Significance of foreign characteristics
*
test istar dloecdy

* double checking overvaln mistake
* list country date overvaln in 1/66

* THIS IS TABLE FOR COLUMN 2

predict prob
replace prob=1 if prob>.5 & prob~=.
replace prob=0 if prob<.5
tab prob eventld if c6sample==1

** cutoff = 0.25
predict prob4
replace prob4=1 if prob4>.25 & prob4~=.
replace prob4=0 if prob4<.25
tab prob4 eventld if c6sample==1

log close

